Subject: bug#29909: closed (Re: bug#29909: non-greedy matching (RE2))

From: [email-masked] (GNU bug Tracking System)
Date: Sat, 30 Dec 2017 23:56:02 +0000

Your bug report

#29909: non-greedy matching (RE2)

which was filed against the sed package, has been closed.

The explanation is attached below, along with your original report.
If you require more details, please reply to [email-masked].

-- 
29909: http://debbugs.gnu.org/cgi/bugreport.cgi?bug=29909
GNU Bug Tracking System
Contact [email-masked] with problems

Subject: Re: bug#29909: non-greedy matching (RE2)
From: Assaf Gordon <[email-masked]>
To: Shawn Landden <[email-masked]>, [email-masked]
Date: Sat, 30 Dec 2017 16:55:11 -0700
List-Id: <debbugs-submit.debbugs.gnu.org>

severity 29909 wishlist
stop

Hello Shawn,

On 2017-12-30 06:01 AM, Shawn Landden wrote:
> It is well known that sed lacks non-greedy regular expression matches.
> This means that sed can only match a subset of regular languages[1].
> Would a proper patch to add re2 support[2], so that sed implements ALL
> regular languages correctly, in O(n) time, be considered?
> 
> [2] https://github.com/google/re2

First,
A working patch is worth 1000 emails :)
if you already have something working, that will go a long way
towards considering this feature.

However,
 From a cursory look, I would say using RE2 in GNU sed is not likely.
RE2 is a C++ library, and while there is a C wrapper for it,
it will make compiling GNU sed much more complicated than it is today.

It could be added as an optional dependency,
but GNU sed is included in many "minimal" installation, and those will 
likely opt not to add additional libraries to their minimal setup -
so by default most users won't benefit from RE2 at all.

There was an attempt to add PCRE support for GNU sed (which has been 
shelved for now). PCRE is much more commonly available than RE2,
and if any effort is done in this direction, I would think focusing
on reviving the PCRE patch would be more effective.

As such, I'm marking this ticket as a "wishlist" item and closing it,
but discussion can continue by replying to this thread.

regards,
  - assaf

Subject: non-greedy matching (RE2)
From: Shawn Landden <[email-masked]>
To: [email-masked]
Date: Sat, 30 Dec 2017 05:01:12 -0800
List-Id: <debbugs-submit.debbugs.gnu.org>

It is well known that sed lacks non-greedy regular expression matches.
This means that sed can only match a subset of regular languages[1].
Would a proper patch to add re2 support[2], so that sed implements ALL
regular languages correctly, in O(n) time, be considered?

Thanks,

Shawn Landden

[1] https://en.wikipedia.org/wiki/Regular_language#Location_in_the_Chomsky_hierarchy
And because that link isn't very good, 28c3: The Science of Insecurity
https://www.youtube.com/watch?v=3kEfedtQVOY
[2] https://github.com/google/re2